#!/usr/bin/env python
import re
from shutil import copy2
import os
import threading
import subprocess

class CDLocker:
    def __init__(self):
            pass

    def startup(self,options):
        t = threading.Thread(target=self._startup)
        t.daemon = True
        t.start()

    def _startup(self):
        try:
            if objects.has_key("VariablesManager"):
                objects["VariablesManager"].register_trigger("CDLOCK_ACTIVE","CDLocker",self.do_action)
            self.do_action()
        except Exception as e:
            print str(e)

    def getState(self,*args,**kwargs):
        try:
            if objects.has_key("VariablesManager"):
                state=objects["VariablesManager"].get_variable("CDLOCK_ACTIVE")
                if state == None or state == '0':
                    return [True,0]
                else:
                    return [True,1]
            else:
                return [False]
        except Exception as e:
            return [False,str(e)]

    def enable(self,*args,**kwargs):
        dstfile="/etc/udev/rules.d/60-cdrom_id.rules"
        origfile="/lib/udev/rules.d/60-cdrom_id.rules"
        tmpfile="/tmp/cdlocker_tmp_rules"
        if not os.path.exists(dstfile):
            if os.path.exists(origfile):
                try:
                    copy2(origfile,dstfile)
                except Exception as e:
                    return [False,str(e)]
        try:
            with open(dstfile,"r") as f:
                changed=False
                with open(tmpfile,"w") as out:
                    for line in f:
                        m = re.match("^(ENV{DISK_EJECT_REQUEST}==.*)",line);
                        if not m:
                            out.write(line)
                        else:
                            changed=True
                            out.write('#'+m.group(1)+"\n")
            if changed:
                try:
                    copy2(tmpfile, dstfile)
                    subprocess.call(['/bin/chmod','0700','/usr/bin/eject'])
                    subprocess.call(['/usr/bin/eject','-i','on','/dev/sr0'])
                except Exception as e:
                    return [False,str(e)]
            return [True,"Enabled now!"]
        except Exception as e:
            return [False,str(e)]

    def disable(self,*args,**kwargs):
        dstfile="/etc/udev/rules.d/60-cdrom_id.rules"
        origfile="/lib/udev/rules.d/60-cdrom_id.rules"
        tmpfile="/tmp/cdlocker_tmp_rules"
        if not os.path.exists(dstfile):
            if os.path.exists(origfile):
                try:
                    copy2(origfile,dstfile)
                except Exception as e:
                    return [False,str(e)]
        try:
            with open(dstfile,"r") as f:
                changed=False
                with open(tmpfile,"w") as out:
                    for line in f:
                        m = re.match("^#(ENV{DISK_EJECT_REQUEST}==.*)",line);
                        if not m:
                            out.write(line)
                        else:
                            changed=True
                            out.write(m.group(1)+"\n")
            if changed:
                try:
                    copy2(tmpfile, dstfile)
                    subprocess.call(['/bin/chmod','0755','/usr/bin/eject'])
                    subprocess.call(['/usr/bin/eject','-i','off','/dev/sr0'])
                except Exception as e:
                    return [False,str(e)]
            return [True,"Disabled now!"]
        except Exception as e:
            return [False,str(e)]

    def do_action(self,*args,**kwargs):
        result,state=self.getState()
        if result == True:
            if state == 1:
                r,txt=self.enable()
            else:
                r,txt=self.disable()
        else:
            r=False
        if r == True:
            return [True,txt]
        else:
            return [False,txt]

if __name__ == '__main__':
    cdl=CDLocker()
    print cdl.getState()